/*
Memory Management with Belady's Anomaly versin 1.0, Copyright (C) 2008 Ricardo Santacruz Bautista, Alejandro Prez Reyna, Juan Luis Gutierrez Pallares

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program.  If not, see <http://www.gnu.org/licenses/>.

Feel free to send comments or questions to: 
Ricardo Santacruz (prodor@gmail.com) Alejandro Prez (cw_fromhell@yahoo.com.mx)Juan Gutierrez (jlgpallares@hotmail.com)

Memory Management with Belady's Anomaly versin 1.0, Copyright (C) 2008 Ricardo Santacruz Bautista, Alejandro Prez Reyna, Juan Luis Gutierrez Pallares 



*/

/*
Simulador de manejo de memoria con implementacin de la anomala de Belady versin 1.0, 
Copyright (C) 2008 Ricardo Santacruz Bautista, Alejandro Prez Reyna, Juan Luis Gutirrez 
Pallares.

Este programa es software libre. Puede redistribuirlo y/o modificarlo bajo los trminos de 
la Licencia Pblica General de GNU segn es publicada por la Free Software Foundation, bien
de la versin 2 de dicha Licencia o bien (segn su eleccin) de cualquier versin 
posterior. 

Este programa se distribuye con la esperanza de que sea til, pero SIN NINGUNA GARANTA, 
incluso sin la garanta MERCANTIL implcita o sin garantizar la CONVENIENCIA PARA UN 
PROPSITO PARTICULAR. Vase la Licencia Pblica General de GNU para ms detalles. 

Usted debi haber recibido una copia de la licencia publica GNU junto con este programa, en 
caso contrario, visite <http://www.gnu.org/licenses/>.

Cualquier duda escribanos a cualquiera de estos correos electronicos:
Ricardo Santacruz (prodor@gmail.com) Alejandro Prez (cw_fromhell@yahoo.com.mx)Juan 
Gutierrez (jlgpallares@hotmail.com)

Simulador de manejo de memoria con implementacin de la anomala de Belady versin 1.0, 
Copyright (C) 2008 Ricardo Santacruz Bautista, Alejandro Prez Reyna, Juan Luis Gutirrez 
Pallares.

 */
// Memory Management modified to simulate Beladys Anomaly by:
// Juan Luis Gutierrez Pallares 
// Alejandro Perez Reyna
// Ricardo Santacruz Bautista
// Buap Students http://www.cs.buap.mx
// 
// The main MemoryManagement program, created by Alexander Reeder, 2000 Nov 19

import java.applet.*;
import java.awt.*;
import java.io.*;
import java.util.*;
//import ControlPanel;
//import PageFault;
//import Virtual2Physical;
//import Common;
//import Page;

public class MemoryManagement 
{
  public static void main(String[] args) 
  {
    ControlPanel controlPanel;
    Kernel kernel;

    if ( args.length < 1 || args.length > 2 ) 
    {
      System.out.println( "Usage: 'java MemoryManagement <COMMAND FILE> <PROPERTIES FILE>'" );
      System.exit( -1 );
    } 

    File f = new File( args[0] );

    if ( ! ( f.exists() ) ) 
    {
      System.out.println( "MemoryM: error, file '" + f.getName() + "' does not exist." );
      System.exit( -1 );
    }
    if ( ! ( f.canRead() ) ) 
    {
      System.out.println( "MemoryM: error, read of " + f.getName() + " failed." );
      System.exit( -1 );
    }

    if ( args.length == 2 ) 
    {
      f = new File( args[1] );

      if ( ! ( f.exists() ) ) 
      {
        System.out.println( "MemoryM: error, file '" + f.getName() + "' does not exist." );
        System.exit( -1 );
      }
      if ( ! ( f.canRead() ) ) 
      {
        System.out.println( "MemoryM: error, read of " + f.getName() + " failed." );
        System.exit( -1 );
      } 
    }

    kernel = new Kernel();
    controlPanel = new ControlPanel( "Memory Management" );
    if ( args.length == 1 ) 
    {
      controlPanel.init( kernel , args[0] , null );
    }
    else
    {
      controlPanel.init( kernel , args[0] , args[1] );
    }
  }
}
